#include "GUI.hpp"


/*Function to handle the input*/
auto GUI_Window::handle(int e) -> int {
    switch (e) {
        /*Mousebutton*/
        case FL_PUSH:
            vkvm::callEvent(vkvm::EventType::MouseButton);
            if (Fl::event_button() == FL_LEFT_MOUSE) {
                std::cout << "Mouse:left" << std::endl;
            } else if (Fl::event_button() == FL_RIGHT_MOUSE) {
                std::cout << "Mouse:right" << std::endl;
            } else {
                std::cout << "Mouse:middle" << std::endl;
            }
            return 1;
            /*Mousebutton and movement*/
        case FL_DRAG:
            vkvm::callEvent(vkvm::EventType::MouseButton);
            vkvm::callEvent(vkvm::EventType::MouseMove);
            x = Fl::event_x();
            y = Fl::event_y();
            vkvm::setMousePosition(x,y);
            if (Fl::event_button() == FL_LEFT_MOUSE) {
                std::cout << "Mouse:left" << std::endl;
            } else if (Fl::event_button() == FL_RIGHT_MOUSE) {
                std::cout << "Mouse:right" << std::endl;
            } else {
                std::cout << "Mouse:middle" << std::endl;
            }
            return 1;
            /*Mousemovement*/
        case FL_MOVE:
            vkvm::callEvent(vkvm::EventType::MouseMove);
            x = Fl::event_x();
            y = Fl::event_y();
            vkvm::setMousePosition(x,y);
            return 1;
            /*keyboardbutton*/
        case FL_KEYBOARD:
            vkvm::callEvent(vkvm::EventType::KeyDown);
            button = Fl::event_button();
            keyCode = new vkvm::KeyCode(button);
            vkvm::buttonPressed(*keyCode);
            return 1;
        case FL_KEYUP:
            vkvm::callEvent(vkvm::EventType::KeyUp);
            button = Fl::event_button();
            std::cout<<button<<std::endl;
            keyCode = new vkvm::KeyCode(button);
            vkvm::buttonPressed(*keyCode);
            return 1;
    }

}

GUI_Window::GUI_Window(int x, int y, const char *l) : Fl_Window(x, y, l) {}


